`include "RamInitSynBank00.txt"
`include "RamInitSynBank01.txt"
`include "RamInitSynBank02.txt"
`include "RamInitSynBank10.txt"
`include "RamInitSynBank11.txt"
`include "RamInitSynBank12.txt"

module RAMB4_S8(DO, ADDR, DI, EN, CLK, WE, RST); // synthesis syn_black_box
input  WE;
input  EN;
input  CLK;
input  RST;
input  [8:0]ADDR;
input  [7:0]DI;
output [7:0]DO;
reg    [7:0]DO;
parameter [255:0] INIT_00 = 256'h0, INIT_01 = 256'h0, INIT_02 = 256'h0, INIT_03 = 256'h0,
INIT_04 = 256'h0, INIT_05 = 256'h0, INIT_06 = 256'h0, INIT_07 = 256'h0,
INIT_08 = 256'h0, INIT_09 = 256'h0, INIT_0A = 256'h0, INIT_0B = 256'h0,
INIT_0C = 256'h0, INIT_0D = 256'h0, INIT_0E = 256'h0, INIT_0F = 256'h0;

reg [7:0]mem[511:0];
reg [8:0]addr_reg;
reg [11:0]I;

initial
begin
for( I=12'b0; I <= 12'd255 ; I=I+12'd8 )
   mem[I[11:3]] <= {INIT_00[I] ,INIT_00[I+1],INIT_00[I+2],INIT_00[I+3],INIT_00[I+4],INIT_00[I+5],INIT_00[I+6],INIT_00[I+7]};
for( I=12'd256; I <= 12'd511 ; I=I+12'd8 )
   mem[I[11:3]] <= {INIT_01[I] ,INIT_01[I+1],INIT_01[I+2],INIT_01[I+3],INIT_01[I+4],INIT_01[I+5],INIT_01[I+6],INIT_01[I+7]};
for( I=12'd512; I <= 12'd767 ; I=I+8 )
   mem[I[11:3]] <= {INIT_02[I] ,INIT_02[I+1],INIT_02[I+2],INIT_02[I+3],INIT_02[I+4],INIT_02[I+5],INIT_02[I+6],INIT_02[I+7]};
for( I=12'd768; I <= 12'd1023 ; I=I+8 )
   mem[I[11:3]] <= {INIT_03[I] ,INIT_03[I+1],INIT_03[I+2],INIT_03[I+3],INIT_03[I+4],INIT_03[I+5],INIT_03[I+6],INIT_03[I+7]};
for( I=12'h400; I <= 12'h4FF ; I=I+8 )
   mem[I[11:3]] <= {INIT_04[I] ,INIT_04[I+1],INIT_04[I+2],INIT_04[I+3],INIT_04[I+4],INIT_04[I+5],INIT_04[I+6],INIT_04[I+7]};
for( I=12'h500; I <= 12'h5FF ; I=I+8 )
   mem[I[11:3]] <= {INIT_05[I] ,INIT_05[I+1],INIT_05[I+2],INIT_05[I+3],INIT_05[I+4],INIT_05[I+5],INIT_05[I+6],INIT_05[I+7]};
for( I=12'h600; I <= 12'h6FF ; I=I+8 )
   mem[I[11:3]] <= {INIT_06[I] ,INIT_06[I+1],INIT_06[I+2],INIT_06[I+3],INIT_06[I+4],INIT_06[I+5],INIT_06[I+6],INIT_06[I+7]};
for( I=12'h700; I <= 12'h7FF ; I=I+8 )
   mem[I[11:3]] <= {INIT_07[I] ,INIT_07[I+1],INIT_07[I+2],INIT_07[I+3],INIT_07[I+4],INIT_07[I+5],INIT_07[I+6],INIT_07[I+7]};
for( I=12'h800; I <= 12'h8FF ; I=I+8 )
   mem[I[11:3]] <= {INIT_08[I] ,INIT_08[I+1],INIT_08[I+2],INIT_08[I+3],INIT_08[I+4],INIT_08[I+5],INIT_08[I+6],INIT_08[I+7]};
for( I=12'h900; I <= 12'h9FF ; I=I+8 )
   mem[I[11:3]] <= {INIT_09[I] ,INIT_09[I+1],INIT_09[I+2],INIT_09[I+3],INIT_09[I+4],INIT_09[I+5],INIT_09[I+6],INIT_09[I+7]};
for( I=12'hA00; I <= 12'hAFF ; I=I+8 )
   mem[I[11:3]] <= {INIT_0A[I] ,INIT_0A[I+1],INIT_0A[I+2],INIT_0A[I+3],INIT_0A[I+4],INIT_0A[I+5],INIT_0A[I+6],INIT_0A[I+7]};
for( I=12'hB00; I <= 12'hBFF ; I=I+8 )
   mem[I[11:3]] <= {INIT_0B[I] ,INIT_0B[I+1],INIT_0B[I+2],INIT_0B[I+3],INIT_0B[I+4],INIT_0B[I+5],INIT_0B[I+6],INIT_0B[I+7]};
for( I=12'hC00; I <= 12'hCFF ; I=I+8 )
   mem[I[11:3]] <= {INIT_0C[I] ,INIT_0C[I+1],INIT_0C[I+2],INIT_0C[I+3],INIT_0C[I+4],INIT_0C[I+5],INIT_0C[I+6],INIT_0C[I+7]};
for( I=12'hD00; I <= 12'hDFF ; I=I+8 )
   mem[I[11:3]] <= {INIT_0D[I] ,INIT_0D[I+1],INIT_0D[I+2],INIT_0D[I+3],INIT_0D[I+4],INIT_0D[I+5],INIT_0D[I+6],INIT_0D[I+7]};
for( I=12'hE00; I <= 12'hEFF ; I=I+8 )
   mem[I[11:3]] <= {INIT_0E[I] ,INIT_0E[I+1],INIT_0E[I+2],INIT_0E[I+3],INIT_0E[I+4],INIT_0E[I+5],INIT_0E[I+6],INIT_0E[I+7]};
for( I=12'hF00; I <= 12'hFFF ; I=I+8 )
   mem[I[11:3]] <= {INIT_0F[I] ,INIT_0F[I+1],INIT_0F[I+2],INIT_0F[I+3],INIT_0F[I+4],INIT_0F[I+5],INIT_0F[I+6],INIT_0F[I+7]};
end

always@(posedge CLK)
	if(EN)
		if(RST == 1)
			DO <= 0;
		else
	begin
		if(WE == 1)
			DO <= DI;
		else
			DO <= mem[ADDR];
	end

always @(posedge CLK)
	if (EN && WE) mem[ADDR] = DI;

endmodule

module VideoMem ( data, ADDR, LINENO, CLK );
output[ 7:0] data;
input [10:0] ADDR;
input LINENO;
input CLK;

reg [7:0]data;

wire  [ 7:0] data_out00;
wire  [ 7:0] data_out01;
wire  [ 7:0] data_out02;
wire  [ 7:0] data_out10;
wire  [ 7:0] data_out11;
wire  [ 7:0] data_out12;

wire en00;
wire en01;
wire en02;
wire en10;
wire en11;
wire en12;

reg [5:0]enold;

assign en00 = (~LINENO)&(~ADDR[10])&(~ADDR[9]);
assign en01 = (~LINENO)&(~ADDR[10])&(ADDR[9]);
assign en02 = (~LINENO)&(ADDR[10]);

assign en10 = (LINENO)&(~ADDR[10])&(~ADDR[9]);
assign en11 = (LINENO)&(~ADDR[10])&(ADDR[9]);
assign en12 = (LINENO)&(ADDR[10]);

`include "RamInitSimBank0.txt"
RAMB4_S8 BANK00( .WE(1'b0), .EN( 1'b1 ), .CLK(CLK), .ADDR(ADDR[8:0]), .DI(8'h00), .DO(data_out00), .RST(1'b0) )`initbank00;
RAMB4_S8 BANK01( .WE(1'b0), .EN( 1'b1 ), .CLK(CLK), .ADDR(ADDR[8:0]), .DI(8'h00), .DO(data_out01), .RST(1'b0) )`initbank01;
RAMB4_S8 BANK02( .WE(1'b0), .EN( 1'b1 ), .CLK(CLK), .ADDR(ADDR[8:0]), .DI(8'h00), .DO(data_out02), .RST(1'b0) )`initbank02;

`include "RamInitSimBank1.txt"
RAMB4_S8 BANK10( .WE(1'b0), .EN( 1'b1 ), .CLK(CLK), .ADDR(ADDR[8:0]), .DI(8'h00), .DO(data_out10), .RST(1'b0) )`initbank10;
RAMB4_S8 BANK11( .WE(1'b0), .EN( 1'b1 ), .CLK(CLK), .ADDR(ADDR[8:0]), .DI(8'h00), .DO(data_out11), .RST(1'b0) )`initbank11;
RAMB4_S8 BANK12( .WE(1'b0), .EN( 1'b1 ), .CLK(CLK), .ADDR(ADDR[8:0]), .DI(8'h00), .DO(data_out12), .RST(1'b0) )`initbank12;

always @(posedge CLK)
begin
  enold[0] <= en00;
  enold[1] <= en01;
  enold[2] <= en02;
  enold[3] <= en10;
  enold[4] <= en11;
  enold[5] <= en12;
end

always @( enold or data_out00 or data_out01 or data_out02 or data_out10 or data_out11 or data_out12 )
begin
data = data_out00;
case( enold )
6'd1 : data = data_out00;
6'd2 : data = data_out01;
6'd4 : data = data_out02;
6'd8 : data = data_out10;
6'd16: data = data_out11;
6'd32: data = data_out12;
endcase
end

endmodule
